public class Aufgabe3 {

    /*
    Aufgabe:
        Rekursive Methoden.
        Verändern Sie die Implementierungen der Methoden dieser Klasse entsprechend
        den Kommentaren an den mit TODO gekennzeichneten Stellen.

        Die Methoden sollen Ihr Ein-/Ausgabeverhalten auf gültigen Eingaben behalten.

        Der Programmcode soll OHNE SCHLEIFEN und OHNE GLOBALEN VARIABLEN
        (Variablen, die außerhalb eines Methodenrumpfs deklariert werden) auskommen!

        Die gegebenen Methodenköpfe sollen nicht verändert werden.
        Zusätzliche Hilfsmethoden sind nicht erlaubt.

    Punkte (maximal 20):
        8 Punkte für die Implementierung von 'factors',
        6 Punkte für die Implementierung von 'f',
        6 Punkte für die Implementierung von 'printArray',
    */

    // Liefert alle Primfaktoren von n die im Intervall i bis n liegen.
    // Zwischen zwei Zahlen steht ein '.' als Trennzeichen.
    // Vorbedingung: n > 0 und i > 0 und i <= n
    public static String factors(int n, int i) {
        //TODO: Ersetzen Sie die Schleife durch Rekursion
if( i > n) {
    return "";
}

return (n % i == 0 ? i + "." + factors(n / i, i) : i + "." + factors(n, ++i));

    }
    public static int f(int n) {
        //TODO: Entfernen Sie die Rekursion.
        if(n < 0) {
            return (-n + 1) % 2;
        } else {
            return n % 2;
        }
    }

    // Gibt alle Elemente aus 'array' mit den Indizes 'from' bis 'to' (inklusive)
    // mit Tabulator als Trennzeichen aus.
    // Vorbedingung: array != null, 'from' und 'to' sind gültige Indizes für die
    // gilt: from <= to.
    // Diese Methode soll ohne Schleife auskommen und ohne Aufruf von
    // Methoden aus java.util.Arrays.
    public static void printArray(int[] array, int from, int to) {
        if(from < to) {
            System.out.print(array[from] + "\n");
            printArray(array, ++from, to);
        } else if(from == to) {
            System.out.print(array[from]);
        }

    }

    // Diese Methode können Sie zum Testen nutzen. Geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

    }

}

